using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SpringPCSCAPI;

namespace SCardTK
{
  public partial class ApduParametersForm : Form
  {
    private string CLA = "";
    private string INS = "";
    private string P1 = "";
    private string P2 = "";
    private string LC = "";
    private string DATAIN = "";
    private string LE = "";
    private string RawApdu = "";
    private SCardTKForm parent;

#region initialize form
    public ApduParametersForm(string ApduCmdStr, SCardTKForm parentFrm)
    {
      InitializeComponent();
      parent = parentFrm;
      char[] limit = { ';' };
      char[] limitChoices = {','};
      char[] toRemove = { '{', '}' };
      string[] ApduBytes = ApduCmdStr.Split(limit);
      this.Text += ApduBytes[0];
      if (ApduBytes[1].StartsWith("X"))
      {
        textBoxForCla.Visible = true;
      }
      else
      {
        if (ApduBytes[1].StartsWith("{"))
        {
          string ListChoices = ApduBytes[1].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForCla.Items.Add(choices[i]);
          comboBoxForCla.Visible = true;
        }else
        {
          labelForCla.Text = ApduBytes[1];
          labelForCla.Visible = true;
          if(ApduBytes[1] != "-")
            CLA = ApduBytes[1];
        }
      }

      if (ApduBytes[2].StartsWith("X"))
      {
        textBoxForIns.Visible = true;
      }
      else
      {
        if (ApduBytes[2].StartsWith("{"))
        {
          string ListChoices = ApduBytes[2].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForIns.Items.Add(choices[i]);
          comboBoxForIns.Visible = true;
        }else
        {
          labelForIns.Text = ApduBytes[2];
          labelForIns.Visible = true;
          if (ApduBytes[2] != "-")
            INS = ApduBytes[2];
        }
      }

      if (ApduBytes[3].StartsWith("X"))
      {
        textBoxForP1.Visible = true;
      }
      else
      {
        if (ApduBytes[3].StartsWith("{"))
        {
          string ListChoices = ApduBytes[3].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForP1.Items.Add(choices[i]);
          comboBoxForP1.Visible = true;
        }else
        {
          labelForP1.Text = ApduBytes[3];
          labelForP1.Visible = true;
          if (ApduBytes[3] != "-")
            P1 = ApduBytes[3];
        }
      }

      if (ApduBytes[4].StartsWith("X") )
      {
        textBoxForP2.Visible = true;
      }else
      {
        if(ApduBytes[4].StartsWith("{"))
        {
          string ListChoices = ApduBytes[4].Trim(toRemove);
          string[]choices = ListChoices.Split(limitChoices);
          for(int i= 0; i<choices.Length;i++)
            comboBoxForP2.Items.Add(choices[i]);
          comboBoxForP2.Visible = true;
        }else
        {
          labelForP2.Text = ApduBytes[4];
          labelForP2.Visible = true;
          if (ApduBytes[4] != "-")
            P2 = ApduBytes[4];
        }
      }

      if (ApduBytes[5].StartsWith("X"))
      {
        textBoxForLc.Visible = true;
      }
      else
      {
        if (ApduBytes[5].StartsWith("{"))
        {
          string ListChoices = ApduBytes[5].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForLc.Items.Add(choices[i]);
          comboBoxForLc.Visible = true;
        }else
        {
          labelForLc.Text = ApduBytes[5];
          labelForLc.Visible = true;
          if (ApduBytes[5] != "-")
            LC = ApduBytes[5];
        }
      }

      if (ApduBytes[6].StartsWith("X"))
      {
        textBoxForDataIn.Visible = true;
      }
      else
      {
        if (ApduBytes[6].StartsWith("{"))
        {
          string ListChoices = ApduBytes[6].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForDataIn.Items.Add(choices[i]);
          comboBoxForDataIn.Visible = true;
        }else
        {
          labelForDataIn.Text = ApduBytes[6];
          labelForDataIn.Visible = true;
          if (ApduBytes[6] != "-")
            DATAIN = ApduBytes[6];
        }
      }

      if (ApduBytes[7].StartsWith("X"))
      {
        textBoxForLe.Visible = true;
      }
      else
      {
        if (ApduBytes[7].StartsWith("{"))
        {
          string ListChoices = ApduBytes[7].Trim(toRemove);
          string[] choices = ListChoices.Split(limitChoices);
          for (int i = 0; i < choices.Length; i++)
            comboBoxForLe.Items.Add(choices[i]);
          comboBoxForLe.Visible = true;
        }else
        {
          labelForLe.Text = ApduBytes[7];
          labelForLe.Visible = true;
          if (!ApduBytes[7].StartsWith("-"))
            LE = ApduBytes[7];
        }
      }


    }
#endregion

#region get values from combo boxes
    private void comboBoxForCla_SelectedIndexChanged(object sender, EventArgs e)
    {
      CLA = comboBoxForCla.SelectedItem.ToString();
    }

    private void comboBoxForIns_SelectedIndexChanged(object sender, EventArgs e)
    {
      INS = comboBoxForIns.SelectedItem.ToString();
    }

    private void comboBoxForP1_SelectedIndexChanged(object sender, EventArgs e)
    {
      P1 = comboBoxForP1.SelectedItem.ToString();
    }

    private void comboBoxForP2_SelectedIndexChanged(object sender, EventArgs e)
    {
      P2 = comboBoxForP2.SelectedItem.ToString();
    }

    private void comboBoxForLc_SelectedIndexChanged(object sender, EventArgs e)
    {
      LC = comboBoxForLc.SelectedItem.ToString();
    }

    private void comboBoxForDataIn_SelectedIndexChanged(object sender, EventArgs e)
    {
      DATAIN = comboBoxForDataIn.SelectedItem.ToString();
    }

    private void comboBoxForLe_SelectedIndexChanged(object sender, EventArgs e)
    {
      LE = comboBoxForLe.SelectedItem.ToString();
    }

#endregion

    private void buttonCancel_Click(object sender, EventArgs e)
    {
      this.Close();
      this.Dispose();
    }

#region retreive information
    private void buttonOK_Click(object sender, EventArgs e)
    {
      /* We create an APDUCmd with the information given/entered by user */
      this.RawApdu = this.CLA + this.INS + this.P1 + this.P2 + this.LC +
        this.DATAIN + this.LE;

      
      parent.SetApdu(RawApdu.Replace("0x","").Replace(" ",""));
      /* The main form will display in the APDU panel and run the APDUCmd  */
      this.Close();
      this.Dispose();
    }
#endregion


#region retreive values from text boxes
    private void textBoxForLe_TextChanged(object sender, EventArgs e)
    {
      LE = textBoxForLe.Text;
    }

    private void textBoxForDataIn_TextChanged(object sender, EventArgs e)
    {
      DATAIN = textBoxForDataIn.Text;
    }

    private void textBoxForLc_TextChanged(object sender, EventArgs e)
    {
      LC = textBoxForLc.Text;
    }

    private void textBoxForP2_TextChanged(object sender, EventArgs e)
    {
      P2 = textBoxForP2.Text;
    }

    private void textBoxForP1_TextChanged(object sender, EventArgs e)
    {
      P1 = textBoxForP1.Text;
    }

    private void textBoxForIns_TextChanged(object sender, EventArgs e)
    {
      INS = textBoxForIns.Text;
    }

    private void textBoxForCla_TextChanged(object sender, EventArgs e)
    {
      CLA = textBoxForCla.Text;
    }

#endregion


  }
}