using System;
using System.Collections.Generic;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.IO;
using SpringPCSCAPI;

namespace SCardTK
{
  public partial class SCardTKForm : Form
  {
    private string SelectedReader = "";
    private NameValueCollection CollectionApdu = new NameValueCollection();
    private char[] delimiterItem = {';'};
    private char[] delimiterCmd = { '=' };
    private char[] delimiterline = { '\n' };
    public string ScriptFileName = "";


#region forms management
    public SCardTKForm()
    {
      SplashForm MySplashForm = new SplashForm();

      /* Showing configuration form - User has to select reader */
      ConfigReaderForm cf = new ConfigReaderForm(this,true);
      cf.Show();

     
      MySplashForm.Show();

     
      InitializeComponent();

     
    }

  #region menuItems
    private void aboutSCardTKToolStripMenuItem_Click(object sender, EventArgs e)
    {
      // display about form
      AboutForm aboutFrm = new AboutForm();
      aboutFrm.ShowDialog();
    }

    private void setDefaultCLAToolStripMenuItem_Click(object sender, EventArgs e)
    {
      ForceClaForm Fcf = new ForceClaForm(this);
      Fcf.ShowDialog();
    }

    private void chooseAReaderToolStripMenuItem_Click(object sender, EventArgs e)
    {
      // display config reader form
      ConfigReaderForm configFrm = new ConfigReaderForm(this,false);
      configFrm.ShowDialog();
    }
  #endregion

  #region TextBoxes 
    private void InstextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if ((e.KeyCode == Keys.Back) && (InstextBox.Text.Length == 0))
      {
        ClatextBox.Focus();
        if (ClatextBox.Text.Length != 0)
        {
          ClatextBox.Text = ClatextBox.Text.Remove(1);
          ClatextBox.SelectionStart = 1;
        }
      }

      if ((InstextBox.Text.Length == 1) && (e.KeyCode != Keys.Back))
        P1textBox.Focus();
    }


    private void P1textBox_KeyDown(object sender, KeyEventArgs e)
    {
      if ((e.KeyCode == Keys.Back) && (P1textBox.Text.Length == 0))
      {
        InstextBox.Focus();
        if (InstextBox.Text.Length != 0)
        {
          InstextBox.Text = InstextBox.Text.Remove(1);
          InstextBox.SelectionStart = 1;
        }
      }
      if ((P1textBox.Text.Length == 1) && (e.KeyCode != Keys.Back))
        P2textBox.Focus();
    }

    private void P2textBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && P2textBox.Text.Length == 0)
      {
        P1textBox.Focus();
        if (P1textBox.Text.Length != 0)
        {
          P1textBox.Text = P1textBox.Text.Remove(1);
          P1textBox.SelectionStart = 1;
        }
      }

      if ((P2textBox.Text.Length == 1) && (e.KeyCode != Keys.Back))
        LctextBox.Focus();
    }



    private void DataintextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && DataintextBox.Text.Length == 0)
      {
        LctextBox.Focus();
        if (LctextBox.Text.Length != 0)
        {
          LctextBox.Text = LctextBox.Text.Remove(1);
          LctextBox.SelectionStart = 1;
        }
      }
    }

    private void LctextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && LctextBox.Text.Length == 0)
      {
        P2textBox.Focus();
        if (P2textBox.Text.Length != 0)
        {
          P2textBox.Text = P2textBox.Text.Remove(1);
          P2textBox.SelectionStart = 1;
        }
      }

      if ((LctextBox.Text.Length == 1) && (e.KeyCode != Keys.Back))
        DataintextBox.Focus();
    }

    private void LetextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Back && LetextBox.Text.Length == 0)
      {
        DataintextBox.Focus();
        if (DataintextBox.Text.Length != 0)
        {
          DataintextBox.Text = DataintextBox.Text.Remove(DataintextBox.Text.Length - 1);
          DataintextBox.SelectionStart = DataintextBox.Text.Length;
        }
      }

      if ((LetextBox.Text.Length == 1) && (e.KeyCode != Keys.Back))
        buttonRun.Focus();
    }

    private void ClatextBox_KeyDown(object sender, KeyEventArgs e)
    {
      if ((ClatextBox.Text.Length == 1) && (e.KeyCode != Keys.Back))
        InstextBox.Focus();
    }
  #endregion

    public void SetApdu(string rawAPDU)
    {
      clearAll();
     
      string properStr = rawAPDU.Replace(" ", "").Replace("0x", "");
      if (properStr.Length >= 8)
      {
        ClatextBox.Text = properStr.Substring(0, 2);
        InstextBox.Text = properStr.Substring(2, 2);
        P1textBox.Text = properStr.Substring(4, 2);
        P2textBox.Text = properStr.Substring(6, 2);
      }
      if (properStr.Length == 10)
        LetextBox.Text = properStr.Substring(8,2);

      if (properStr.Length > 10)
      {
        // here we have to determine if LE is present or not
        // LC will give us DataIn size
        LctextBox.Text = properStr.Substring(8,2);
        if (properStr.Length > int.Parse(LctextBox.Text)*2 + 10)
        {
          //last byte is LE
          if (properStr.Length - 4 >= 10)
          {
            for (int cpt = 10; cpt < properStr.Length - 2; cpt = cpt+2)
              if(cpt+2< properStr.Length)
                DataintextBox.Text += properStr.Substring(cpt, 2);
          }
          LetextBox.Text = properStr.Substring(properStr.Length-2, 2);
        }
        else
        {
          for (int cpt = 10; cpt < properStr.Length; cpt = cpt+2)
            if (cpt + 2 < properStr.Length)
              DataintextBox.Text += properStr.Substring(cpt, 2);
        }

      }
      RawApduTextBox.Text = rawAPDU;
    }


    private void butClear_Click(object sender, EventArgs e)
    {
      clearAll();
    }

    private void SCardTKForm_KeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.F5)
        buttonRun_Click(sender, e);
    }

    private void buttonClearHisto_Click(object sender, EventArgs e)
    {
      ResultTextBox.Clear();
      DataOutTextBox.Clear();
    }


    private void clearAll()
    {
      // clear all text boxes 
      ClatextBox.Clear();
      InstextBox.Clear();
      P1textBox.Clear();
      P2textBox.Clear();
      LctextBox.Clear();
      DataintextBox.Clear();
      LetextBox.Clear();
      RawApduTextBox.Clear();
    }

    public void changeCla(string newCla)
    {
      // first we change cla in CollectionApdu
      string[] ApduNames = CollectionApdu.AllKeys;
      for (int cpt = 0; cpt < ApduNames.Length; cpt++)
      {
        // looking for first occurence of ';'
        int startIndex = CollectionApdu[ApduNames[cpt]].IndexOf(';');
        int stopIndex = 
          CollectionApdu[ApduNames[cpt]].Remove(startIndex,1).IndexOf(';');
        CollectionApdu[ApduNames[cpt]] =
          CollectionApdu[ApduNames[cpt]].Remove(startIndex + 1, 4).Insert(startIndex + 1, newCla);
        
      }

      // then we change its value in treeView
       //enumNode  = CmdtreeView.Nodes.GetEnumerator;
      foreach (TreeNode config in CmdtreeView.Nodes)
      {
        foreach (TreeNode command in config.Nodes)
        {
          foreach (TreeNode paramater in command.Nodes)
          {
            if (paramater.Text.StartsWith("CLA"))
              paramater.Text = "CLA : " + newCla;
          }
        }
      }
   
    }


#endregion

#region communication functions

    private void timerStatus_Tick(object sender, EventArgs e)
    {
      CardStatustextBox.Text = SPCSC.CheckStatus();
      if (CardStatustextBox.Text == "")
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Hide();
        buttonDisco.Hide();
        buttonConnect.Text = "Connect";
      }
      if (CardStatustextBox.Text.Contains("PRESENT"))
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Show();
        buttonDisco.Hide();
        buttonConnect.Text = "Connect"; 
      }
      if (CardStatustextBox.Text.Contains("INUSE"))
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Show();
        pictureBoxP.Hide();
        buttonDisco.Show();
        buttonConnect.Text = "Reconnect";
      }
      if (CardStatustextBox.Text.Contains("EMPTY"))
      {
        pictureBoxAbs.Show();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Hide();
        buttonDisco.Hide();
        buttonConnect.Text = "Connect";
      }
      
    }

    public void SCardTkDisconnect(string mode)
    {
      if (mode == "RESET")
        SPCSC.Disconnect(SPCSC.SCARD_RESET_CARD);
      if (mode == "EJECT")
        SPCSC.Disconnect(SPCSC.SCARD_EJECT_CARD);
      if (mode == "LEAVE")
        SPCSC.Disconnect(SPCSC.SCARD_LEAVE_CARD);
      if (mode == "UNPOWER")
        SPCSC.Disconnect(SPCSC.SCARD_UNPOWER_CARD);
    }

    public void SetReader(string readerName)
    {
      SelectedReader = readerName;
      SPCSC.SetReader(SelectedReader);
      if (SelectedReader == "")
      {
        SelectedReader = "None";
        MessageBox.Show(" Set a reader in menu Configuration - Choose a Reader", "No Reader selected");
      }
      StatusText.Text = "Selected reader : " + SelectedReader;
    }

    private void buttonRun_Click(object sender, EventArgs e)
    {
      /* we check if text was entered  */
      if (RawApduTextBox.Text == "")
        return;
      
      /* First we test if the text entered is hexadecimal */
      Regex regHex = new Regex("^[0-9a-fA-f ]*$");
      if (!regHex.IsMatch(RawApduTextBox.Text))
      {
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("Invalid format. Only hexadecimal allowed\n");
        return;
      }

      string properStr = RawApduTextBox.Text;
      /* then we test if length is correct */
      /* we remove every space character, to test if length is even */
      if(RawApduTextBox.Text.Contains(" "))
      {
        properStr = RawApduTextBox.Text.Replace(" ", "");
      }
      if(properStr.Length %2 != 0)
      {
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("\nInvalid length.\n");
        return;
      }

      RunApdu(RawApduTextBox.Text);

    }

    private void RunApdu(string RawApdu)
    {
      APDUCmd cmd = new APDUCmd(RawApdu.Replace(" ",""));
      APDURsp answer = new APDURsp();
      
      ResultTextBox.SelectionColor = Color.Black;
      ResultTextBox.AppendText("\nSending : ");
      ResultTextBox.SelectionColor = Color.Blue;
      ResultTextBox.AppendText(cmd.APDUStr);

      if (!SPCSC.Transmit(cmd, ref answer))
      {
        ResultTextBox.SelectionColor = Color.Red;
        ResultTextBox.AppendText("\nError during Transmit, check that card is connected \n");
        ResultTextBox.AppendText("Current card status : " + SPCSC.CheckStatus()+"\n");     
      }
      else
      {
        ResultTextBox.SelectionColor = Color.Black;
        ResultTextBox.AppendText("\nReceived : ");
        ResultTextBox.SelectionColor = Color.Red;
        if (answer.APDUStr != null)
        {
          ResultTextBox.AppendText(answer.APDUStr + " - ");
          ResultTextBox.AppendText(SPCSC.StatusWordsToStr(answer.SW1, answer.SW2));
          DataOutTextBox.Text = answer.DataOutStr;
        }
        else
        { ResultTextBox.AppendText(" Reader Error : Transmit succeeded but no answer received. ");
        }

        ResultTextBox.AppendText("\n");
      }
    }

    private void buttonConnect_Click(object sender, EventArgs e)
    {
      if (buttonConnect.Text == "Reconnect")
      {
        SPCSC.Reconnect();
      }
      else
      {
        // disconnect before connecting
        SPCSC.Disconnect();
        SPCSC.ConnectCard();
        buttonConnect.Text = "Reconnect";
      }
      pictureBoxAbs.Hide();
      pictureBoxAl.Show();
      pictureBoxC.Hide();
      pictureBoxP.Hide();
      buttonDisco.Show();
    }

#endregion

#region config file

    private void openConfigFileToolStripMenuItem_Click(object sender, EventArgs e)
    {
      openConfigDialog.ShowDialog();
    }

    private void ReadConfigFile(object sender, CancelEventArgs e)
    {
      char[] delimiterLine = {'\n'};
      
      Stream userFileStream = new FileStream(openConfigDialog.FileName,
        FileMode.Open, FileAccess.Read);
      StreamReader userFileStreamReader = new StreamReader(userFileStream);
      string userFileString = userFileStreamReader.ReadToEnd();
   
      
      string[] userFileLines = userFileString.Replace("\r\n\r\n","\r\n").
        Replace("0x","").Replace("\r","").Split(delimiterLine);
      string[] cmdArray;
      string[] ApduArray;
      TreeNode MainNode = new TreeNode();
      
      for (int cpt = 0; cpt < userFileLines.Length; cpt++)
      {
        if ((userFileLines[cpt].StartsWith("[")) && 
          (userFileLines[cpt].EndsWith("]")))
        {
          // new node 
          MainNode = new TreeNode();
          MainNode.Text = 
            userFileLines[cpt].Substring(1, userFileLines[cpt].Length - 2);
          CmdtreeView.Nodes.Add(MainNode);

        }
        else
        {
          cmdArray = userFileLines[cpt].Split(delimiterItem);
          if (cmdArray.Length != 7) // Checking if line syntax is correct
            continue;
          TreeNode byteNode = new TreeNode();
          ApduArray = cmdArray[0].Split(delimiterCmd);
          CollectionApdu.Add(ApduArray[0], 
            userFileLines[cpt].Replace("=",";"));
          byteNode.Text = ApduArray[0];
          MainNode.Nodes.Add(byteNode);
          byteNode.Nodes.Add("CLA : " + ApduArray[1].Trim());
          byteNode.Nodes.Add("INS : " + cmdArray[1].Trim());
          byteNode.Nodes.Add("P1 : " + cmdArray[2].Trim());
          byteNode.Nodes.Add("P2 : " + cmdArray[3].Trim());
          byteNode.Nodes.Add("LC : " + cmdArray[4].Trim());
          byteNode.Nodes.Add("DataIn : " + cmdArray[5].Trim());
          byteNode.Nodes.Add("LE : " + cmdArray[6].Trim());
        }
      }
      

      userFileStreamReader.Close();
      userFileStream.Close();
    }

#endregion

# region TreeView
    private void CmdtreeView_MouseDoubleClick(object sender, MouseEventArgs e)
    {
      /*  Display ApduParameter Dialog to configure APDU  */
      if (CmdtreeView.SelectedNode.Level == 1)
      {
        ApduParametersForm Apf =
          new ApduParametersForm(CollectionApdu[CmdtreeView.SelectedNode.Text], this);
        Apf.ShowDialog();
      }
    }

    private void CmdtreeView_MouseClick(object sender, MouseEventArgs e)
    {
      if (CmdtreeView.SelectedNode != null)
      {
        /* Display in Apdu Panel's textBoxes the Apdu  */
        if (CmdtreeView.SelectedNode.Level == 1)
        {
          clearAll();
          string[] ApduSelected =
              CollectionApdu[CmdtreeView.SelectedNode.Text].Split(delimiterItem);

          if (!ApduSelected[1].StartsWith("{") && !ApduSelected[1].StartsWith("X") &&
            !ApduSelected[1].StartsWith("-"))
          {
            ClatextBox.Text = ApduSelected[1];
          }
          else
            ClatextBox.Text = "";

          if (!ApduSelected[2].StartsWith("{") && !ApduSelected[2].StartsWith("X") &&
            !ApduSelected[2].StartsWith("-"))
          {
            InstextBox.Text = ApduSelected[2];
          }
          else
            InstextBox.Text = "";

          if (!ApduSelected[3].StartsWith("{") && !ApduSelected[3].StartsWith("X") &&
            !ApduSelected[3].StartsWith("-"))
          {
            P1textBox.Text = ApduSelected[3];
          }
          else
            P1textBox.Text = "";

          if (!ApduSelected[4].StartsWith("{") && !ApduSelected[4].StartsWith("X") &&
            !ApduSelected[4].StartsWith("-"))
          {
            P2textBox.Text = ApduSelected[4];
          }
          else
            P2textBox.Text = "";

          if (!ApduSelected[5].StartsWith("{") && !ApduSelected[5].StartsWith("X") &&
            !ApduSelected[5].StartsWith("-"))
          {
            LctextBox.Text = ApduSelected[5];
          }
          else
            LctextBox.Text = "";

          if (!ApduSelected[6].StartsWith("{") && !ApduSelected[6].StartsWith("X") &&
            !ApduSelected[6].StartsWith("-"))
          {
            DataintextBox.Text = ApduSelected[6];
          }
          else
            DataintextBox.Text = "";

          if (!ApduSelected[7].StartsWith("{") && !ApduSelected[7].StartsWith("X") &&
            !ApduSelected[7].StartsWith("-"))
          {
            LetextBox.Text = ApduSelected[7];
          }
          else
            LetextBox.Text = "";

        }
      }
    }
#endregion

# region Update text boxes
    private void UpdateRawApduText() 
    {
      RawApduTextBox.Text = ClatextBox.Text + InstextBox.Text + P1textBox.Text +
        P2textBox.Text + LctextBox.Text + DataintextBox.Text + LetextBox.Text;
    }

    private void ClatextBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

    private void InstextBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

    private void P1textBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

    private void P2textBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

    private void LctextBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

    private void DataintextBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

    private void LetextBox_TextChanged(object sender, EventArgs e)
    {
      UpdateRawApduText();
    }

#endregion

    private void splitContainer2_Panel1_Resize(object sender, EventArgs e)
    {
      RawApduTextBox.Width = splitContainer2.Panel1.Width - 43;
      LetextBox.Location = new System.Drawing.Point(splitContainer2.Panel1.Width - 61, 
        24);
      labelLe.Location = new Point(splitContainer2.Panel1.Width - 66, 8);
      DataintextBox.Width = splitContainer2.Panel1.Width - 222;
      butClear.Location = new Point(splitContainer2.Panel1.Width - 91, 
        100);
      buttonRun.Location = new Point(splitContainer2.Panel1.Width / 2 - 65, 99);
    }

    private void splitContainer3_Panel2_Resize(object sender, EventArgs e)
    {
      CardStatustextBox.Width = splitContainer3.Panel2.Width - 290;
    }

    private void splitContainer4_Panel2_Resize(object sender, EventArgs e)
    {
      buttonClearHisto.Location = new System.Drawing.Point(splitContainer4.Panel2.Width - 110, 3);
      DataOutTextBox.Width = splitContainer4.Panel2.Width - 245;
    }

    private void saveToolStripMenuItem_Click(object sender, EventArgs e)
    {
      string Script = ResultTextBox.Text; 
      // is there anything to save?
      if (Script != "")
      {
        if (ScriptFileName == "")
        {//no default file
          saveFileDialog.ShowDialog();
        }
        else
        {// writing on default file 
          writeFile();
        }
      }
    }

    private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
    {
      ScriptFileName = saveFileDialog.FileName;
      writeFile();
    }

    public void writeFile()
    {
      // getting user entry
      string Script = ResultTextBox.Text;
      string[] lines = Script.Split(delimiterline);

      Stream writeFileStream = new FileStream(ScriptFileName,
        FileMode.OpenOrCreate, FileAccess.Write);
      StreamWriter writeFileStreamWriter = new StreamWriter(writeFileStream);

      foreach (string line in lines)
      {
        
        if (line.StartsWith("Sending :"))
        {
          writeFileStreamWriter.WriteLine(line.Replace("Sending : ", "\r\n#Sending : \r\n"));
          
        }
        else
        {
          if (line.Trim().Length != 0)
            writeFileStreamWriter.WriteLine(line.Insert(0, "#"));
        }
      }

      writeFileStreamWriter.Close();
      writeFileStream.Close();

    }

    private void runALoggedSessionToolStripMenuItem_Click(object sender, EventArgs e)
    {
      openLogFileDialog.ShowDialog();
    }

    private void openLogFileDialog_FileOk(object sender, CancelEventArgs e)
    {
      Stream userFileStream = new FileStream(openLogFileDialog.FileName,
        FileMode.Open, FileAccess.Read);
      StreamReader userFileStreamReader = new StreamReader(userFileStream);
      string userFileString = userFileStreamReader.ReadToEnd();
      userFileStreamReader.Close();
      userFileStream.Close();

      string[] lines = userFileString.Split(delimiterline);
      foreach (string line in lines)
      {
        if (line.Trim() == "")
          continue;
        // skip comment
        if (line.Trim().StartsWith("#"))
          continue;
        Regex regHex = new Regex("^[0-9a-fA-f ]*$");
        if (!regHex.IsMatch(line.Trim()))
        {
          
          continue;
        }
        RunApdu(line.Trim());
      }
     
    }

    private void testAllCLAToolStripMenuItem_Click(object sender, EventArgs e)
    {
      for (byte b = 0x00; b <= 0xFE; b++)
        RunApdu("FF" + String.Format("{0:X02}",b)+ "000000");
    }

    private void buttonDisco_Click(object sender, EventArgs e)
    {
      // prompting for disconnect mode : EJETC, RESET, LEAVE or UNPOWER
      DiscoForm Dfrm = new DiscoForm(this);
      Dfrm.ShowDialog();
    }







  }
}