// APDUDlg.cpp : implementation file
//

#include "stdafx.h"
#include "shlwapi.h"
#include "APDUDlg.h"

#include "winscard.h"


SCARDCONTEXT Context;
SCARDHANDLE Card;

DWORD ActiveProtocol;

static UINT BASED_CODE indicators[] =
{
    ID_INDICATOR_ERROR
};

// APDUDlg dialog

IMPLEMENT_DYNAMIC(APDUDlg, CDialog)

APDUDlg::APDUDlg(CWnd* pParent /*=NULL*/)
	: CDialog(APDUDlg::IDD, pParent)
{
}

APDUDlg::~APDUDlg()
{
}

void APDUDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT4, readerBox);
  DDX_Control(pDX, IDC_EDIT1, cardBox);
	DDX_Control(pDX, IDC_EDIT3, answerBox);
	DDX_Control(pDX, IDC_EDIT2, apduBox);
	DDX_Control(pDX, IDOK, Okbtn);
}


BEGIN_MESSAGE_MAP(APDUDlg, CDialog)
	ON_BN_CLICKED(IDOK, &APDUDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &APDUDlg::OnCancel)
	ON_WM_CLOSE() 
END_MESSAGE_MAP()


// APDUDlg message handlers

void APDUDlg::SetReader(LPCTSTR inReader)
{
	reader = inReader;
}

BOOL APDUDlg::OnInitDialog()
{
	LONG rv;
	CString str;
  

	
	CDialog::OnInitDialog();
	readerBox.ReplaceSel(reader);

	status_bar.Create(this); //We create the status bar


	status_bar.SetIndicators(indicators,1); //Set the number of panes 

	CRect rect;
	GetClientRect(&rect);
	//Size the two panes

	status_bar.SetPaneInfo(0,ID_INDICATOR_ERROR, 
			SBPS_NORMAL,rect.Width()-100);      

	//This is where we actually draw it on the screen

	RepositionBars(AFX_IDW_CONTROLBAR_FIRST,AFX_IDW_CONTROLBAR_LAST,
			ID_INDICATOR_ERROR);
	// create new context
  rv = SCardEstablishContext(SCARD_SCOPE_SYSTEM, NULL, NULL, &Context);
	if(rv != SCARD_S_SUCCESS)
	{
	  status_bar.SetPaneText(0,_T("Cannot establish context"));
	}

	// connect card
  GetATR();

	return true;
}

void APDUDlg::OnClose() 
{
	LONG rv;
	rv = SCardDisconnect(Card, SCARD_UNPOWER_CARD);
	rv = SCardReleaseContext(Context);
	EndDialog(0);
}

void APDUDlg::OnCancel() 
{
	OnClose();
}

void APDUDlg::GetATR() 
{
 
 LONG rv;
 CString protStr;
 status_bar.SetPaneText(0,_T("Reading card... "));
 rv = SCardConnect(Context,reader, SCARD_SHARE_SHARED,
    (SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1), &Card, &ActiveProtocol);
 CString str,str2;
 DWORD    cByte = SCARD_AUTOALLOCATE;
 DWORD dwState, dwProtocol, dwAtrLen, dwReaderLen;
 BYTE pbAtr[MAX_ATR_SIZE];

 switch ( ActiveProtocol )
 {
    case SCARD_PROTOCOL_T0:
        protStr = _T("Active protocol T=0"); 
        break;

    case SCARD_PROTOCOL_T1:
        protStr = _T("Active protocol T=1"); 
        break;

    default:
        protStr = _T("Active protocol unnegotiated or unknown"); 
        break;
 }
 
 status_bar.SetPaneText(0,protStr); 
 
 
 if(rv == SCARD_S_SUCCESS)
 { 
	 dwAtrLen = sizeof(pbAtr);
	 status_bar.SetPaneText(0,_T("Card found, retreiving ATR"));
	 rv=SCardStatus(Card, NULL, &dwReaderLen, &dwState, &dwProtocol,
    pbAtr, &dwAtrLen);
	 if(rv == SCARD_S_SUCCESS)
	 { 	
		 status_bar.SetPaneText(0,_T("ATR successfully read"));
		 for (int i = 0; i < (int) dwAtrLen; i++){
					str2.Format(_T("%X"), *(pbAtr+i));
					str += str2;
		 }
					cardBox.ReplaceSel(str);
					Okbtn.EnableWindow();
					apduBox.EnableWindow();
					status_bar.SetPaneText(0,protStr); 
	 }else
	 {
		 //str = evtStr(rv);
		 if (str == _T(""))
		 {
			 str2.Format(_T("%d "), rv);	
			 str = _T("Unkwon error occurred while calling SCardStatus : ");
			 str += str2; 
		 }
		 status_bar.SetPaneText(0,str);
	 }
 }else 
 {
	 //str = evtStr(rv);
	 if (str == _T(""))
	 {
		 str2.Format(_T("%d "), rv);
		 str = _T("Unkwon error occurred while calling SCardConnect : ");
		 str += str2;
	 }
	 status_bar.SetPaneText(0,str);
 }

}
void APDUDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	//OnOK();
	CString str,str2=_T(" "), cmdUsr;
	BYTE rcvBuf[260];
	LONG lResult;

	answerBox.SetWindowTextW(str2);
	apduBox.GetWindowTextW(cmdUsr);
  
	CString strTemp=cmdUsr;
	
	// removing hexadecimal prefix 0x
	cmdUsr.Replace(_T("0x"),_T(""));
	// removing spaces
	cmdUsr.Replace(_T(" "),_T(""));

	int HdrInt;
  BOOL isIntorHex;	
  int nbTokens =0;
	

	CString HexStr;

	BYTE tmpBuf[MAX_SIZE_APDU];

	for(size_t i = 0; i< _tcslen(cmdUsr)/2 ; i++)
	{
		HexStr = _T("0x")+ (CString) cmdUsr[(int)(i*2)] + 
			(CString) cmdUsr[(int)(i*2+1)];
		isIntorHex = StrToIntEx(HexStr, STIF_SUPPORT_HEX, &HdrInt);
		if(isIntorHex)
		{
			 tmpBuf[nbTokens] = (BYTE) HdrInt;
			 nbTokens++;
		}
		else
		{
			CString s;
			s.Format(_T("value %d is not Hexadecimal"),nbTokens+1);
			MessageBox(s);
		}
	}

  
	BYTE * sndBuf = new BYTE[nbTokens];
	for(int j = 0; j<nbTokens ; j++)
	{
		sndBuf[j] = tmpBuf[j];
	}
	
	strTemp.ReleaseBuffer(); 

  
	DWORD dwOutLength = sizeof(rcvBuf);
	LPCSCARD_IO_REQUEST SendPci;
	if (ActiveProtocol == SCARD_PROTOCOL_T0)
	{
		SendPci = SCARD_PCI_T0;
	}else
	{
		SendPci = SCARD_PCI_T1;
	}
  

	lResult = SCardTransmit(Card,SendPci,sndBuf,nbTokens,
		NULL,rcvBuf,&dwOutLength);

	 str = _T(" ");
	 if(lResult == SCARD_S_SUCCESS)
	 { 
		 for (int i = 0; i <(int) dwOutLength; i++)
		 {
				str2.Format(_T("%02X "), *(rcvBuf+i));
				str += str2;
		 }
				answerBox.ReplaceSel(str);
	 }else
	 {
		 //str = evtStr(lResult);
		 if (str == _T(""))
		 {
			 str2.Format(_T("%d "), lResult);	
			 str = _T("Unkwon error occurred while calling SCardTransmit : ");
			 str += str2; 
		 }
		 status_bar.SetPaneText(0,str);
	 }
}

