// CardCommunicationMFCDlg.cpp : implementation file
//


#include "stdafx.h"
#include "shlwapi.h"
#include "CardCommunicationMFC.h"
#include "CardCommunicationMFCDlg.h"
#include "states_strings.c"
#include "winscard.h"

#define MAX_ATR_SIZE 32
#ifdef _DEBUG
#define new DEBUG_NEW
#endif



SCARDCONTEXT hContext;
SCARDHANDLE hCard;
CString protocoleStr;
DWORD dwActiveProtocol;
DWORD States[MAXIMUM_SMARTCARD_READERS];

DWORD dwReadersOld;


static UINT BASED_CODE indicators[] =
{
    ID_INDICATOR_ERROR
};


// CCardCommunicationMFCDlg dialog




CCardCommunicationMFCDlg::CCardCommunicationMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCardCommunicationMFCDlg::IDD, pParent)
	, ParentWnd(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_SC_ICON);
}

void CCardCommunicationMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Control(pDX, IDC_BUTAPDU, Exchange_but);
}

BEGIN_MESSAGE_MAP(CCardCommunicationMFCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTAPDU, &CCardCommunicationMFCDlg::OnBnClickedButAPDU)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, &CCardCommunicationMFCDlg::OnNMDblclkList)
	ON_BN_CLICKED(IDC_BUTDIRECT, &CCardCommunicationMFCDlg::OnBnClickedButdirect)
	ON_NOTIFY(NM_CLICK, IDC_LIST, &CCardCommunicationMFCDlg::OnNMClickList)
END_MESSAGE_MAP()


// CCardCommunicationMFCDlg message handlers


BOOL CCardCommunicationMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// timer for readers list
	SetTimer(1,100,0);

	// splashScreen
	CSplashScreenEx *pSplash=new CSplashScreenEx();
	pSplash->Create(this,NULL,2000,CSS_FADE | CSS_CENTERSCREEN | CSS_SHADOW);
	pSplash->SetBitmap(IDB_SPLASHAE,200,200,200);
	pSplash->SetTextFont(_T("Verdana"),70,CSS_TEXT_NORMAL);
	pSplash->SetTextRect(CRect(520,10,600,30));
	pSplash->SetTextColor(RGB(0,0,0));
	pSplash->SetTextFormat( DT_VCENTER);
  pSplash->SetText(_T("20080915"));
	pSplash->SetTextRectBottom(CRect(4,360,500,500));
  pSplash->SetTextBottom(_T("SPRINGCARD, the SPRINGCARD logo, PRO ACTIVE and the PRO ACTIVE logo are registered\n\r trademarks of PRO ACTIVE SAS. All other trademarks are property of their respective owners.\n\r See LICENSE.txt for more information.  Copyright (c) Pro Active 2008"));
	pSplash->Show();
  

	// status bar
  m_bar.Create(this); //We create the status bar
	m_bar.SetIndicators(indicators,1); //Set the number of panes 
	CRect rect;
	GetClientRect(&rect);
	//Size the two panes
	m_bar.SetPaneInfo(0,ID_INDICATOR_ERROR, 
			SBPS_NORMAL,rect.Width()-100);      
	//This is where we actually draw it on the screen
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST,AFX_IDW_CONTROLBAR_LAST,
			ID_INDICATOR_ERROR);

  // List View
	m_List.InsertColumn(0,_T("Reader Name"),LVCFMT_LEFT,210);
	m_List.InsertColumn(1,_T("Status"),LVCFMT_LEFT,150);
	m_List.InsertColumn(2,_T("Card ATR"),LVCFMT_LEFT,175);
	m_List.SetExtendedStyle(m_List.GetExtendedStyle() | LVS_EX_FULLROWSELECT);
  
	dwReadersOld = 0;
	m_List.DeleteAllItems();

	// About Dialog
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCardCommunicationMFCDlg::OnTimer(UINT_PTR nIDEvent)
{
	 ListStatusReaders();
	 selectedIndex = m_List.GetSelectionMark();
	 if (m_List.GetItemText(selectedIndex,1) == _T("SCARD_STATE_PRESENT"))
	 {
		 Exchange_but.EnableWindow();
	 }else
	 {
		 Exchange_but.EnableWindow(0);
	 }

}

void CCardCommunicationMFCDlg::ListStatusReaders()
{
	LONG rv;
	LPTSTR          pmszReaders = NULL;
	LONG            lReturn;
	DWORD           cch = SCARD_AUTOALLOCATE;
	DWORD Timeout =0, dwReaders;
  
 rv = SCardEstablishContext(SCARD_SCOPE_SYSTEM, NULL, NULL, &hContext);
 if(rv == SCARD_S_SUCCESS)
 { 
	 lReturn = SCardListReaders(hContext,NULL,(LPTSTR)&pmszReaders,&cch ); 
	 if(lReturn == SCARD_S_SUCCESS)
	 { 
		if (pmszReaders == NULL)
		{
			 m_bar.SetPaneText(0,_T("No reader found"));
		} else
		{
      dwReaders = GetNbReaders(pmszReaders);
			if (dwReadersOld != dwReaders)
		  {
				ClearList(dwReaders);
        BuildList(pmszReaders);
				m_List.SetSelectionMark(selectedIndex);
	      m_List.SetItemState(selectedIndex,LVIS_SELECTED, LVIS_SELECTED);
				dwReadersOld = dwReaders;
		  }
			else
			{
				DisplayStatus(pmszReaders);
	      m_bar.SetPaneText(0,_T("Select a reader"));
			}
		}
		
	 }else 
	 {
		 m_bar.SetPaneText(0,_T("Cannot get Readers list"));
		 dwReadersOld = 0;
	   m_List.DeleteAllItems();
	}
				
 }else 
 {
	 m_bar.SetPaneText(0,_T("Cannot establish context"));
 }
 rv = SCardReleaseContext(hContext);

}

void CCardCommunicationMFCDlg::ClearList(DWORD newNb)
{
  selectedReaderName = m_List.GetItemText(selectedIndex,0);
	m_List.DeleteAllItems();
  DWORD i;
	// set every status on unaware state
	for (i=0; i<newNb; i++)
		States[i]= SCARD_STATE_UNAWARE;
}

void CCardCommunicationMFCDlg::BuildList(LPTSTR pmszReaders)
{			
	LPTSTR pReader = pmszReaders;
  DWORD dwReaders;

	for (dwReaders=0; dwReaders<MAXIMUM_SMARTCARD_READERS; dwReaders++)
	{
		/* End of multi-string array */
		if (*pReader == '\0')
			break;
    m_List.InsertItem(dwReaders,pReader );
		if(pReader == selectedReaderName)
		{
			m_List.SetSelectionMark(dwReaders);
	    m_List.SetItemState(dwReaders,LVIS_SELECTED, LVIS_SELECTED);
		}
		/* Jump to next entry in multi-string array */
		pReader += _tcslen(pReader) + 1;

	}
}

void CCardCommunicationMFCDlg::DisplayStatus(LPTSTR pmszReaders)
{
	SCARD_READERSTATE rgscState[MAXIMUM_SMARTCARD_READERS];
	LPTSTR pReader = pmszReaders;
  DWORD dwReaders,i,j;
	LONG rv;
	CString stateStr;
  CString str,strAPDU;

	for (dwReaders=0; dwReaders<MAXIMUM_SMARTCARD_READERS; dwReaders++)
	{
		/* End of multi-string array */
		if (*pReader == '\0')
			break;
    
		rgscState[dwReaders].dwCurrentState = States[dwReaders];
		/* Remember this reader's name */
		rgscState[dwReaders].szReader = pReader;

		/* Jump to next entry in multi-string array */
		pReader += _tcslen(pReader) + 1;
	}
	// display each status
	rv = SCardGetStatusChange(hContext,
													0,
													rgscState,
													dwReaders);	
	
	for (i=0; i<dwReaders; i++)
	{
		if (rgscState[i].dwEventState & SCARD_STATE_CHANGED)
		{
			// Display reader status
			str = StateToStr(rgscState[i].dwEventState);
			m_List.SetItemText(i, 1, str );	

			//Display card ATR if any
			str = _T("");
			strAPDU = _T("");
			if((rgscState[i].dwEventState & SCARD_STATE_PRESENT) !=0)
			{
				for (j= 0; j < rgscState[i].cbAtr; j++)
				{
						str.Format(_T("%X"), *((rgscState[i].rgbAtr)+j));
						strAPDU += str;
				}
			}
			m_List.SetItemText(i, 2,strAPDU);
			// Remember new current state for next loop 
		  States[i] = rgscState[i].dwEventState;
		}	
		
	}
	
	SCardFreeMemory(hContext, pmszReaders);
	pmszReaders = NULL;		

}

DWORD CCardCommunicationMFCDlg::GetNbReaders(LPTSTR pmszReaders)
{			
	LPTSTR pReader = pmszReaders;
  DWORD dwReaders;

	for (dwReaders=0; dwReaders<MAXIMUM_SMARTCARD_READERS; dwReaders++)
	{
		/* End of multi-string array */
		if (*pReader == '\0')
			break;

		/* Jump to next entry in multi-string array */
		pReader += _tcslen(pReader) + 1;

	}
  return dwReaders;
}

void CCardCommunicationMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg *dlgAbout=new CAboutDlg();
		dlgAbout->DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCardCommunicationMFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCardCommunicationMFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}




void CCardCommunicationMFCDlg::OnBnClickedButAPDU()
{
	// Source code for APDU button
  
  CString SelectedReader;

	if(selectedIndex != -1) // if selection
	{
    KillTimer(1);
    SelectedReader = m_List.GetItemText(selectedIndex,0);
		//display APDU Dialog
		APDUDlg ApduD;
		ApduD.SetReader(SelectedReader);
		//ApduD.ShowWindow();
		ApduD.DoModal();
		m_List.SetFocus();
		m_List.SetSelectionMark(selectedIndex);
	  m_List.SetItemState(selectedIndex,LVIS_SELECTED, LVIS_SELECTED);
		
		//Restart timer when done
	  SetTimer(1,100,0);
	}
	
}


void CCardCommunicationMFCDlg::OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
	OnBnClickedButAPDU();
}



void CCardCommunicationMFCDlg::OnBnClickedButdirect()
{
	// TODO: Add your control notification handler code here
	CString SelectedReader;
	if(selectedIndex != -1) // if selection
	{
    KillTimer(1);
		m_List.SetFocus();
		m_List.SetSelectionMark(selectedIndex);
	  m_List.SetItemState(selectedIndex,LVIS_SELECTED, LVIS_SELECTED);
		SelectedReader = m_List.GetItemText(selectedIndex,0);
		//display APDU Dialog
		DirectDlg DirectD;
		DirectD.SetReader(SelectedReader);
	
		//ApduD.ShowWindow();
		DirectD.DoModal();
		
		//Restart timer when done
	  SetTimer(1,100,0);
		
	}
}

void CCardCommunicationMFCDlg::OnNMClickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	// We activate the "exchange" button if a smart card is present
	*pResult = 0;
	selectedIndex = m_List.GetSelectionMark();
 // MessageBox(m_List.GetItemText(selectedIndex,0));
	if (m_List.GetItemText(selectedIndex,1) == _T("SCARD_STATE_PRESENT"))
	{
		Exchange_but.EnableWindow();
	}else
	{
		Exchange_but.EnableWindow(0);
	}

}
