// DirectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "shlwapi.h"
#include "DirectDlg.h"
#include "winscard.h"
#include "evt_strings.c"



#define IOCTL_CSB6_PCSC_ESCAPE SCARD_CTL_CODE(2048)


SCARDCONTEXT RContext;
SCARDHANDLE RCard;

DWORD RActiveProtocol;

static UINT BASED_CODE indicators[] =
{
    ID_INDICATOR_ERROR
};


// DirectDlg dialog

IMPLEMENT_DYNAMIC(DirectDlg, CDialog)

DirectDlg::DirectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(DirectDlg::IDD, pParent)
{

}

DirectDlg::~DirectDlg()
{
}

void DirectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT4, readerBox);
	DDX_Control(pDX, IDC_EDIT3, answerBox);
	DDX_Control(pDX, IDC_EDIT2, apduBox);
	DDX_Control(pDX, IDOK, Okbtn);
}


BEGIN_MESSAGE_MAP(DirectDlg, CDialog)
	ON_BN_CLICKED(IDOK, &DirectDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &DirectDlg::OnCancel)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// DirectDlg message handlers


void DirectDlg::SetReader(LPCTSTR inReader)
{
	reader = inReader;
}

BOOL DirectDlg::OnInitDialog()
{
	LONG rv;
	CString str;
  //LOGFONT lf;
	//CFont m_font;
 
	CDialog::OnInitDialog();
  
/*	memset(&lf, 0, sizeof(LOGFONT));  
  lf.lfHeight = 15;                  
	
  wcscpy_s(lf.lfFaceName, _T("Lucida Console"));   
  m_font.CreateFontIndirect(&lf);
	apduBox.SetFont(&m_font);*/

	readerBox.ReplaceSel(reader);

	status_bar.Create(this); //We create the status bar


	status_bar.SetIndicators(indicators,1); //Set the number of panes 

	CRect rect;
	GetClientRect(&rect);
	//Size the two panes

	status_bar.SetPaneInfo(0,ID_INDICATOR_ERROR, 
			SBPS_NORMAL,rect.Width()-100);      

	//This is where we actually draw it on the screen

	RepositionBars(AFX_IDW_CONTROLBAR_FIRST,AFX_IDW_CONTROLBAR_LAST,
			ID_INDICATOR_ERROR);
	// create new context
  rv = SCardEstablishContext(SCARD_SCOPE_SYSTEM, NULL, NULL, &RContext);
	if(rv != SCARD_S_SUCCESS)
	{
	  status_bar.SetPaneText(0,_T("Cannot establish context"));
	}

	DirectConnect();

	return true;
}

void DirectDlg::OnClose() 
{
	LONG rv;
	rv = SCardDisconnect(RCard, SCARD_UNPOWER_CARD);
	rv = SCardReleaseContext(RContext);
	EndDialog(0);
}

void DirectDlg::OnCancel() 
{
	OnClose();
}


void DirectDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	//OnOK();
	CString str,str2=_T(" "), cmdUsr;
	BYTE rcvBuf[260];
	LONG lResult;

	answerBox.SetWindowTextW(str2);
	apduBox.GetWindowTextW(cmdUsr);
  
	CString strTemp=cmdUsr;
	
	// removing hexadecimal prefix 0x
	cmdUsr.Replace(_T("0x"),_T(""));
	// removing spaces
	cmdUsr.Replace(_T(" "),_T(""));

	int HdrInt;
  BOOL isIntorHex;	
  int nbTokens =0;
	

	CString HexStr;

	BYTE tmpBuf[MAX_SIZE_APDU];

	for(size_t i = 0; i< _tcslen(cmdUsr)/2 ; i++)
	{
		HexStr = _T("0x")+ (CString) cmdUsr[(int)(i*2)] + 
			(CString) cmdUsr[(int)(i*2+1)];
		isIntorHex = StrToIntEx(HexStr, STIF_SUPPORT_HEX, &HdrInt);
		if(isIntorHex)
		{
			 tmpBuf[nbTokens] = (BYTE) HdrInt;
			 nbTokens++;
		}
		else
		{
			CString s;
			s.Format(_T("value %d is not Hexadecimal"),nbTokens+1);
			MessageBox(s);
		}
	}

  
	BYTE * sndBuf = new BYTE[nbTokens];
	for(int j = 0; j<nbTokens ; j++)
	{
		sndBuf[j] = tmpBuf[j];
	}
	
	strTemp.ReleaseBuffer(); 

  
	DWORD dwOutLength = sizeof(rcvBuf);
	LPCSCARD_IO_REQUEST SendPci;
	if (RActiveProtocol == SCARD_PROTOCOL_T0)
	{
		SendPci = SCARD_PCI_T0;
	}else
	{
		SendPci = SCARD_PCI_T1;
	}
  
  lResult = SCardControl(RCard,
		IOCTL_CSB6_PCSC_ESCAPE,
		sndBuf,nbTokens,
		rcvBuf,260,&dwOutLength);

	/*lResult = SCardTransmit(RCard,SendPci,sndBuf,nbTokens,
		NULL,rcvBuf,&dwOutLength);*/
  
	 str = _T(" ");
	 if(lResult == SCARD_S_SUCCESS)
	 { 
		 for (int i = 0; i <(int) dwOutLength; i++)
		 {
				str2.Format(_T("%02X "), *(rcvBuf+i));
				str += str2;
		 }
				answerBox.ReplaceSel(str);
				status_bar.SetPaneText(0,_T("SCardControl returned SCARD_S_SUCCESS"));
	 }else
	 {
		 str = evtStr(lResult);
		 if (str == _T(""))
		 {
			 str2.Format(_T("%d "), lResult);	
			 str = _T("Unkwon error occurred while calling SCardControl : ");
			 str += str2; 
		 }
		 status_bar.SetPaneText(0,str);
	 }
}

void DirectDlg::DirectConnect()
{
  LONG rv;
	CString str;
	DWORD dwActiveProtocol;
  //Essai pour SCardControl, le connect fonctionne,
   //!!!! le GetAttrib parle au driver et non au lecteur 
 rv = SCardConnect(RContext,reader, SCARD_SHARE_DIRECT,
    0, &RCard, &dwActiveProtocol);
 
 
 if (rv == SCARD_S_SUCCESS)
 {
	 str.Format(_T("Connected to %s in DIRECT mode"),reader);
	 Okbtn.EnableWindow();
	 apduBox.EnableWindow();
 }
 else
 {
    str = evtStr(rv);
 }
 status_bar.SetPaneText(0,str);

 /*
 DWORD    cByte = SCARD_AUTOALLOCATE, dwSendLength, dwRecvLength;
 DWORD dwState, dwProtocol, dwAtrLen, dwReaderLen;
 BYTE pbAtr[MAX_ATR_SIZE];
 BYTE pbRecvBuffer[10];
 BYTE pbSendBuffer[] = { 0x06, 0x00, 0x0A, 0x01, 0x01, 0x10, 0x00 };
//0x47   //0x00 C S B 6 ...
 dwSendLength = sizeof(pbSendBuffer);
 dwRecvLength = sizeof(pbRecvBuffer);

// rv = SCardControl(hCard, 3500, pbSendBuffer, dwSendLength,
    //   pbRecvBuffer, sizeof(pbRecvBuffer), &dwRecvLength);
 LPBYTE pbAttr;
 rv = SCardGetAttrib(hCard,
                         SCARD_ATTR_VENDOR_NAME,
                         (LPBYTE)&pbAttr,
                         &cByte);*/


}